/*
 * Ext JS Library 3.0 Pre-alpha
 * Copyright(c) 2006-2008, Ext JS, LLC.
 * licensing@extjs.com
 * 
 * http://extjs.com/license
 
 * Author: Alireza Javid Tajrishi
 * Email : navaro_81@yahoo.com
 * TEL   : +98-912-3894863

*/

Date.SolarMonthNames=['فروردين','ارديبهشت','خرداد','تير','مرداد','شهريور','مهر','آبان','آذر','دي','بهمن','اسفند'];
Date.SolarShortMonthNames=['فروردين','ارديبهشت','خرداد','تير','مرداد','شهريور','مهر','آبان','آذر','دي','بهمن','اسفند'];

Ext.override(Date, {
	calculateSolarDate: function() {
		g_y=this.getFullYear();
		g_m=this.getMonth()+1;
		g_d=this.getDate();
		var g_days_in_month = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		var j_days_in_month = new Array(31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29);
	   var gy, gm, gd;
	   var jy, jm, jd;
	   var g_day_no, j_day_no;
	   var j_np;
	 
	   var i;
	   gy = g_y-1600;
	   gm = g_m-1;
	   gd = g_d-1;
	 
	   g_day_no = 365*gy+Math.floor((gy+3)/4)-Math.floor((gy+99)/100)+Math.floor((gy+399)/400);
	   for (i=0;i<gm;++i)
		  g_day_no += g_days_in_month[i];
	   if (gm>1 && ((gy%4==0 && gy%100!=0) || (gy%400==0)))
		  /* leap and after Feb */
		  ++g_day_no;
	   g_day_no += gd;
	 
	   j_day_no = g_day_no-79;
	 
	   j_np = Math.floor(j_day_no / 12053);
	   j_day_no %= 12053;
	 
	   jy = 979+33*j_np+4*Math.floor((j_day_no/1461));
	   j_day_no %= 1461;
	 
	   if (j_day_no >= 366) {
		  jy += Math.floor((j_day_no-1)/365);
		  j_day_no = (j_day_no-1)%365;
	   }
	 
	   for (i = 0; i < 11 && j_day_no >= j_days_in_month[i]; ++i) {
		  j_day_no -= j_days_in_month[i];
	   }
	   jm = i;
	   jd = j_day_no;
	   
		this.solarYear=jy;
		this.solarMonth=jm;
		this.solarDay=jd+1;	
	},
	getSolarDaysInMonth: function (){
		this.calculateSolarDate();
		if (this.solarMonth<6)
			return 31;
		if (this.solarMonth<11)
			return 30;
		if (this.isLeapYear())
			return 30;
		else
			return 29;
	},
	getSolarDate: function (){
		this.calculateSolarDate();
		return this.solarDay;
	},
	getSolarMonth: function (){
		this.calculateSolarDate();
		return this.solarMonth;
	},
	getSolarFullYear: function (){
		this.calculateSolarDate();
		return this.solarYear;
	},
	getSolarFirstDateOfMonth: function (){
		this.calculateSolarDate();
		return new Date(this.getFullYear(), this.getMonth(), this.getDate() - this.solarDay + 1);
	}
});
Ext.override(Ext.DatePicker, {
	calendarType:'G',
	startDay:6,
    onRender : function(container, position){
        var m = [
             '<table cellspacing="0">',
                '<tr><td class="x-date-left"><a href="#" title="', this.prevText ,'"> </a></td><td class="x-date-middle" align="center"></td><td class="x-date-right"><a href="#" title="', this.nextText ,'"> </a></td></tr>',
                '<tr><td colspan="3"><table class="x-date-inner" cellspacing="0"><thead><tr>'];
        var dn = this.dayNames;
        
        for(var i = 0; i < 7; i++){
            var d = this.startDay+i;
            if(d > 6){
                d = d-7;
            }
            m.push("<th><span>", dn[d].substr(0,1), "</span></th>");
        }
        m[m.length] = "</tr></thead><tbody><tr>";
        for(var i = 0; i < 42; i++) {
            if(i % 7 == 0 && i != 0){
                m[m.length] = "</tr><tr>";
            }
            m[m.length] = '<td><a href="#" hidefocus="on" class="x-date-date" tabIndex="1"><em><span></span></em></a></td>';
        }
        m.push('</tr></tbody></table></td></tr>', 
                this.showToday ? '<tr><td colspan="3" class="x-date-bottom" align="center"></td></tr>' : '', 
                '</table><div class="x-date-mp"></div>');

        var el = document.createElement("div");
        el.className = "x-date-picker";
        el.innerHTML = m.join("");

        container.dom.insertBefore(el, position);

        this.el = Ext.get(el);
        this.eventEl = Ext.get(el.firstChild);

        new Ext.util.ClickRepeater(this.el.child("td.x-date-left a"), {
            handler: this.showPrevMonth,
            scope: this,
            preventDefault:true,
            stopDefault:true
        });

        new Ext.util.ClickRepeater(this.el.child("td.x-date-right a"), {
            handler: this.showNextMonth,
            scope: this,
            preventDefault:true,
            stopDefault:true
        });

        this.mon(this.eventEl, "mousewheel", this.handleMouseWheel, this);

        this.monthPicker = this.el.down('div.x-date-mp');
        this.monthPicker.enableDisplayMode('block');
        
        var kn = new Ext.KeyNav(this.eventEl, {
            "left" : function(e){
                e.ctrlKey ?
                    this.showPrevMonth() :
                    this.update(this.activeDate.add("d", -1));
            },

            "right" : function(e){
                e.ctrlKey ?
                    this.showNextMonth() :
                    this.update(this.activeDate.add("d", 1));
            },

            "up" : function(e){
                e.ctrlKey ?
                    this.showNextYear() :
                    this.update(this.activeDate.add("d", -7));
            },

            "down" : function(e){
                e.ctrlKey ?
                    this.showPrevYear() :
                    this.update(this.activeDate.add("d", 7));
            },

            "pageUp" : function(e){
                this.showNextMonth();
            },

            "pageDown" : function(e){
                this.showPrevMonth();
            },

            "enter" : function(e){
                e.stopPropagation();
                return true;
            },

            scope : this
        });

        this.mon(this.eventEl, "click", this.handleDateClick,  this, {delegate: "a.x-date-date"});

        this.el.unselectable();
        
        this.cells = this.el.select("table.x-date-inner tbody td");
        this.textNodes = this.el.query("table.x-date-inner tbody span");

        this.mbtn = new Ext.Button({
            text: " ",
            tooltip: this.monthYearText,
            renderTo: this.el.child("td.x-date-middle", true)
        });
        
		this.mon(this.mbtn, 'click', this.showMonthPicker, this);
        this.mbtn.el.child('em').addClass("x-btn-arrow");

        if(this.showToday){
            this.todayKeyListener = this.eventEl.addKeyListener(Ext.EventObject.SPACE, this.selectToday,  this);
            var today = (new Date()).dateFormat(this.format);
            this.todayBtn = new Ext.Button({
                renderTo: this.el.child("td.x-date-bottom", true),
                text: String.format(this.todayText, today),
                tooltip: String.format(this.todayTip, today),
                handler: this.selectToday,
                scope: this
            });
        }
		new Ext.Button({
			renderTo: this.el.child("td.x-date-bottom", true),
			text: 'شمسي',
			handler: this.changeCalendar,
			scope: this
		});
        
        if(Ext.isIE){
            this.el.repaint();
        }
        this.update(this.value);
    },    
    updateMPYear : function(y){
        this.mpyear = y;
        var ys = this.mpYears.elements;
        for(var i = 1; i <= 10; i++){
            var td = ys[i-1], y2;
            if((i%2) == 0){
                y2 = y + Math.round(i * .5);
                td.firstChild.innerHTML = y2 - (this.calendarType=='G'?0:622);
                td.xyear = y2;
            }else{
                y2 = y - (5-Math.round(i * .5));
                td.firstChild.innerHTML = y2 - (this.calendarType=='G'?0:622);
                td.xyear = y2;
            }
            this.mpYears.item(i-1)[y2 == this.mpSelYear ? 'addClass' : 'removeClass']('x-date-mp-sel');
        }
    },
    changeCalendar: function(){
		this.calendarType=(this.calendarType=='G')?'J':'G';
		this.update(this.value, true);
		this.updateMPYear(this.value.getFullYear())
		
    },
    update : function(date, forceRefresh){
		this.monthNames=(this.calendarType=='G')?Date.monthNames:Date.SolarMonthNames;

        var vd = this.activeDate;
        this.activeDate = date;
        if(!forceRefresh && vd && this.el){
            var t = date.getTime();
            if(vd.getMonth() == date.getMonth() && vd.getFullYear() == date.getFullYear()){
                this.cells.removeClass("x-date-selected");
                this.cells.each(function(c){
                   if(c.dom.firstChild.dateValue == t){
                       c.addClass("x-date-selected");
                       setTimeout(function(){
                            try{c.dom.firstChild.focus();}catch(e){}
                       }, 50);
                       return false;
                   }
                });
                return;
            }
        }

		var days = date.getDaysInMonth();
        var firstOfMonth = (this.calendarType=='G')?
								date.getFirstDateOfMonth():
								date.getSolarFirstDateOfMonth();		
        
        var startingPos = firstOfMonth.getDay()-this.startDay;

        if(startingPos <= this.startDay)
            startingPos += 7;

		
        var pm =date.add("mo", -1);
        var prevStart = ((this.calendarType=='G')?
							pm.getDaysInMonth():
							pm.getSolarDaysInMonth());
        
        var cells = this.cells.elements;
        var textEls = this.textNodes;
        days += startingPos;

	
/////////////////////////////////////////////////////////////////////////////////////////////////////////
        // convert everything to numbers so it's fast
        var day = 86400000;
        var d = (new Date(pm.getFullYear(), pm.getMonth(), prevStart)).clearTime();
        var today = new Date().clearTime().getTime();
        var sel = date.clearTime().getTime();
        var min = this.minDate ? this.minDate.clearTime() : Number.NEGATIVE_INFINITY;
        var max = this.maxDate ? this.maxDate.clearTime() : Number.POSITIVE_INFINITY;
        var ddMatch = this.disabledDatesRE;
        var ddText = this.disabledDatesText;
        var ddays = this.disabledDays ? this.disabledDays.join("") : false;
        var ddaysText = this.disabledDaysText;
        var format = this.format;
			
        if(this.showToday){
            var td = new Date().clearTime();
            var disable = (td < min || td > max || 
                (ddMatch && format && ddMatch.test(td.dateFormat(format))) || 
                (ddays && ddays.indexOf(td.getDay()) != -1));
                        
            this.todayBtn.setDisabled(disable);
            this.todayKeyListener[disable ? 'disable' : 'enable']();
        }
        
        var setCellClass = function(cal, cell){
            cell.title = "";
            var t = d.getTime() - day;
            cell.firstChild.dateValue = t;
            if(t == today-day){
                cell.className += " x-date-today";
                cell.title = cal.todayText;
            }
            if(t == sel-day){
                cell.className += " x-date-selected";
                setTimeout(function(){
                    try{cell.firstChild.focus();}catch(e){}
                }, 50);
            }
            // disabling
            if(t < min) {
                cell.className = " x-date-disabled";
                cell.title = cal.minText;
                return;
            }
            if(t > max) {
                cell.className = " x-date-disabled";
                cell.title = cal.maxText;
                return;
            }
            if(ddays){
                if(ddays.indexOf(d.getDay()) != -1){
                    cell.title = ddaysText;
                    cell.className = " x-date-disabled";
                }
            }
            if(ddMatch && format){
                var fvalue = d.dateFormat(format);
                if(ddMatch.test(fvalue)){
                    cell.title = ddText.replace("%0", fvalue);
                    cell.className = " x-date-disabled";
                }
            }
        };
        
        
        if (this.calendarType=='G')
			d.setDate(d.getDate()-d.getDay()+d.getFirstDateOfMonth().getDate()-startingPos);
		else
			d.setDate(d.getDate()-d.getDay()+d.getSolarFirstDateOfMonth().getDate()-startingPos);	
		
			
        i=0;
        for(; i < startingPos; i++) {

            textEls[i].innerHTML = (++prevStart);
            d.setDate(d.getDate()+1);
            cells[i].className = "x-date-prevday";
            setCellClass(this, cells[i]);
        }
        for(; i < days; i++){
			var intDay = i - startingPos + 1;
			textEls[i].innerHTML = (intDay);// + '<br>' + ((d.getMonth()+1) + '/' +d.getDate()) + '<BR><small>' + (d.getSolarMonth()+1) + '/' +d.getSolarDate() + '</SMALL>';
			d.setDate(d.getDate()+1);
			cells[i].className = "x-date-active";
			setCellClass(this, cells[i]);
        }
        var extraDays = 0;
        for(; i < 42; i++) {
             textEls[i].innerHTML = (++extraDays);
             d.setDate(d.getDate()+1);
             cells[i].className = "x-date-nextday";
             setCellClass(this, cells[i]);
        }

        this.mbtn.setText(((this.calendarType=='G')?
							this.monthNames[date.getMonth()]:
							Date.SolarMonthNames[date.getSolarMonth()]) + " " + 
						  ((this.calendarType=='G')?
							date.getFullYear():
							date.getSolarFullYear()));
		
        if(!this.internalRender){
            var main = this.el.dom.firstChild;
            var w = main.offsetWidth;
            this.el.setWidth(w + this.el.getBorderWidth("lr"));
            Ext.fly(main).setWidth(w);
            this.internalRender = true;
            if(Ext.isOpera && !this.secondPass){
                main.rows[0].cells[1].style.width = (w - (main.rows[0].cells[0].offsetWidth+main.rows[0].cells[2].offsetWidth)) + "px";
                this.secondPass = true;
                this.update.defer(10, this, [date]);
            }
        }
    }    
});